## javax.servlet
Interface ServletContext

    public interface ServletContext

Defines a set of methods that a servlet uses to communicate with its servlet container, for example, to get the MIME type of a file, dispatch requests, or write to a log file.

There is one context per "web application" per Java Virtual Machine. (A "web application" is a collection of servlets and content installed under a specific subset of the server's URL namespace such as `/catalog` and possibly installed via a `.war` file.)

In the case of a web application marked "distributed" in its deployment descriptor, there will be one context instance for each virtual machine. In this situation, the context cannot be used as a location to share global information (because the information won't be truly global). Use an external resource like a database instead.

The `ServletContext` object is contained within the `ServletConfig` object, which the Web server provides the servlet when the servlet is initialized.

Author:
  Various
See Also:
  `Servlet.getServletConfig()`, `ServletConfig.getServletContext()`

Field Summary
`static java.lang.String` `ORDERED_LIBS` The name of the `ServletContext` attribute whose value (of type `java.util.List<java.lang.String>`) contains the list of names of JAR files in `WEB-INF/lib` ordered by their web fragment names (with possible exclusions if `<absolute-ordering>` without any `<others/>` is being used), or null if no absolute or relative ordering has been specified
`static java.lang.String` `TEMPDIR` The name of the `ServletContext` attribute which stores the private temporary directory (of type `java.io.File`) provided by the servlet container for the `ServletContext`

Method Summary
`FilterRegistration.Dynamic` `addFilter(java.lang.String filterName, java.lang.Class<? extends Filter> filterClass)` Adds the filter with the given name and class type to this servlet context.
`FilterRegistration.Dynamic` `addFilter(java.lang.String filterName, Filter filter)` Registers the given filter instance with this ServletContext under the given `filterName`.
`FilterRegistration.Dynamic` `addFilter(java.lang.String filterName, java.lang.String className)` Adds the filter with the given name and class name to this servlet context.
`void` `addListener(java.lang.Class<? extends java.util.EventListener> listenerClass)` Adds a listener of the given class type to this ServletContext.
`void` `addListener(java.lang.String className)` Adds the listener with the given class name to this ServletContext.

`

`<T extends java.util.EventListener> void`

`

`addListener(T t)`
Adds the given listener to this ServletContext.

`ServletRegistration.Dynamic` `addServlet(java.lang.String servletName, java.lang.Class<? extends Servlet> servletClass)` Adds the servlet with the given name and class type to this servlet context.
`ServletRegistration.Dynamic` `addServlet(java.lang.String servletName, Servlet servlet)` Registers the given servlet instance with this ServletContext under the given `servletName`.
`ServletRegistration.Dynamic` `addServlet(java.lang.String servletName, java.lang.String className)` Adds the servlet with the given name and class name to this servlet context.

`

`<T extends Filter> T`

`

`createFilter(java.lang.Class<T> clazz)`
Instantiates the given Filter class.

`

`<T extends java.util.EventListener> T`

`

`createListener(java.lang.Class<T> clazz)`
Instantiates the given EventListener class.

`

`<T extends Servlet> T`

`

`createServlet(java.lang.Class<T> clazz)`
Instantiates the given Servlet class.

`void` `declareRoles(java.lang.String... roleNames)` Declares role names that are tested using `isUserInRole`.
`java.lang.Object` `getAttribute(java.lang.String name)` Returns the servlet container attribute with the given name, or `null` if there is no attribute by that name.
`java.util.Enumeration<java.lang.String>` `getAttributeNames()` Returns an `Enumeration` containing the attribute names available within this ServletContext.
`java.lang.ClassLoader` `getClassLoader()` Gets the class loader of the web application represented by this ServletContext.
`ServletContext` `getContext(java.lang.String uripath)` Returns a `ServletContext` object that corresponds to a specified URL on the server.
`java.lang.String` `getContextPath()` Returns the context path of the web application.
`java.util.Set<SessionTrackingMode>` `getDefaultSessionTrackingModes()` Gets the session tracking modes that are supported by default for this `ServletContext`.
`int` `getEffectiveMajorVersion()` Gets the major version of the Servlet specification that the application represented by this ServletContext is based on.
`int` `getEffectiveMinorVersion()` Gets the minor version of the Servlet specification that the application represented by this ServletContext is based on.
`java.util.Set<SessionTrackingMode>` `getEffectiveSessionTrackingModes()` Gets the session tracking modes that are in effect for this `ServletContext`.
`FilterRegistration` `getFilterRegistration(java.lang.String filterName)` Gets the FilterRegistration corresponding to the filter with the given `filterName`.
`java.util.Map<java.lang.String,? extends FilterRegistration>` `getFilterRegistrations()` Gets a (possibly empty) Map of the FilterRegistration objects (keyed by filter name) corresponding to all filters registered with this ServletContext.
`java.lang.String` `getInitParameter(java.lang.String name)` Returns a `String` containing the value of the named context-wide initialization parameter, or `null` if the parameter does not exist.
`java.util.Enumeration<java.lang.String>` `getInitParameterNames()` Returns the names of the context's initialization parameters as an `Enumeration` of `String` objects, or an empty `Enumeration` if the context has no initialization parameters.
`JspConfigDescriptor` `getJspConfigDescriptor()` Gets the `<jsp-config>` related configuration that was aggregated from the `web.xml` and `web-fragment.xml` descriptor files of the web application represented by this ServletContext.
`int` `getMajorVersion()` Returns the major version of the Servlet API that this servlet container supports.
`java.lang.String` `getMimeType(java.lang.String file)` Returns the MIME type of the specified file, or `null` if the MIME type is not known.
`int` `getMinorVersion()` Returns the minor version of the Servlet API that this servlet container supports.
`RequestDispatcher` `getNamedDispatcher(java.lang.String name)` Returns a `RequestDispatcher` object that acts as a wrapper for the named servlet.
`java.lang.String` `getRealPath(java.lang.String path)` Gets the real path corresponding to the given virtual path.
`RequestDispatcher` `getRequestDispatcher(java.lang.String path)` Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path.
`java.net.URL` `getResource(java.lang.String path)` Returns a URL to the resource that is mapped to the given path.
`java.io.InputStream` `getResourceAsStream(java.lang.String path)` Returns the resource located at the named path as an `InputStream` object.
`java.util.Set<java.lang.String>` `getResourcePaths(java.lang.String path)` Returns a directory-like listing of all the paths to resources within the web application whose longest sub-path matches the supplied path argument.
`java.lang.String` `getServerInfo()` Returns the name and version of the servlet container on which the servlet is running.

`Servlet`

`getServlet(java.lang.String name)`
Deprecated. As of Java Servlet API 2.1, with no direct replacement.

This method was originally defined to retrieve a servlet from a `ServletContext`. In this version, this method always returns `null` and remains only to preserve binary compatibility. This method will be permanently removed in a future version of the Java Servlet API.

In lieu of this method, servlets can share information using the `ServletContext` class and can perform shared business logic by invoking methods on common non-servlet classes.

`java.lang.String` `getServletContextName()` Returns the name of this web application corresponding to this ServletContext as specified in the deployment descriptor for this web application by the display-name element.

`java.util.Enumeration<java.lang.String>`

`getServletNames()`
Deprecated. As of Java Servlet API 2.1, with no replacement.

This method was originally defined to return an `Enumeration` of all the servlet names known to this context. In this version, this method always returns an empty `Enumeration` and remains only to preserve binary compatibility. This method will be permanently removed in a future version of the Java Servlet API.

`ServletRegistration` `getServletRegistration(java.lang.String servletName)` Gets the ServletRegistration corresponding to the servlet with the given `servletName`.
`java.util.Map<java.lang.String,? extends ServletRegistration>` `getServletRegistrations()` Gets a (possibly empty) Map of the ServletRegistration objects (keyed by servlet name) corresponding to all servlets registered with this ServletContext.

`java.util.Enumeration<Servlet>`

`getServlets()`
Deprecated. As of Java Servlet API 2.0, with no replacement.

This method was originally defined to return an `Enumeration` of all the servlets known to this servlet context. In this version, this method always returns an empty enumeration and remains only to preserve binary compatibility. This method will be permanently removed in a future version of the Java Servlet API.

`SessionCookieConfig` `getSessionCookieConfig()` Gets the `SessionCookieConfig` object through which various properties of the session tracking cookies created on behalf of this `ServletContext` may be configured.
`void` `log(java.lang.Exception exception, java.lang.String msg)` Deprecated. As of Java Servlet API 2.1, use `log(String message, Throwable throwable)` instead. This method was originally defined to write an exception's stack trace and an explanatory error message to the servlet log file.
`void` `log(java.lang.String msg)` Writes the specified message to a servlet log file, usually an event log.
`void` `log(java.lang.String message, java.lang.Throwable throwable)` Writes an explanatory message and a stack trace for a given `Throwable` exception to the servlet log file.
`void` `removeAttribute(java.lang.String name)` Removes the attribute with the given name from this ServletContext.
`void` `setAttribute(java.lang.String name, java.lang.Object object)` Binds an object to a given attribute name in this ServletContext.
`boolean` `setInitParameter(java.lang.String name, java.lang.String value)` Sets the context initialization parameter with the given name and value on this ServletContext.
`void` `setSessionTrackingModes(java.util.Set<SessionTrackingMode> sessionTrackingModes)` Sets the session tracking modes that are to become effective for this `ServletContext`.

Field Detail

### TEMPDIR

    static final java.lang.String TEMPDIR

  The name of the `ServletContext` attribute which stores the private temporary directory (of type `java.io.File`) provided by the servlet container for the `ServletContext`

  See Also:
    Constant Field Values

### ORDERED_LIBS

    static final java.lang.String ORDERED_LIBS

  The name of the `ServletContext` attribute whose value (of type `java.util.List<java.lang.String>`) contains the list of names of JAR files in `WEB-INF/lib` ordered by their web fragment names (with possible exclusions if `<absolute-ordering>` without any `<others/>` is being used), or null if no absolute or relative ordering has been specified

  See Also:
    Constant Field Values

Method Detail

### getContextPath

    java.lang.String getContextPath()

  Returns the context path of the web application.

  The context path is the portion of the request URI that is used to select the context of the request. The context path always comes first in a request URI. The path starts with a `/` character but does not end with a `/` character. For servlets in the default (root) context, this method returns "".

  It is possible that a servlet container may match a context by more than one context path. In such cases the `HttpServletRequest.getContextPath()` will return the actual context path used by the request and it may differ from the path returned by this method. The context path returned by this method should be considered as the prime or preferred context path of the application.

  Returns:
    The context path of the web application, or "" for the default (root) context
  Since:
    Servlet 2.5
  See Also:
    `HttpServletRequest.getContextPath()`

### getContext

    ServletContext getContext(java.lang.String uripath)

  Returns a `ServletContext` object that corresponds to a specified URL on the server.

  This method allows servlets to gain access to the context for various parts of the server, and as needed obtain `RequestDispatcher` objects from the context. The given path must be begin with `/`, is interpreted relative to the server's document root and is matched against the context roots of other web applications hosted on this container.

  In a security conscious environment, the servlet container may return `null` for a given URL.

  Parameters:
    `uripath` - a `String` specifying the context path of another web application in the container.
  Returns:
    the `ServletContext` object that corresponds to the named URL, or null if either none exists or the container wishes to restrict this access.
  See Also:
    `RequestDispatcher`

### getMajorVersion

    int getMajorVersion()

  Returns the major version of the Servlet API that this servlet container supports. All implementations that comply with Version 3.0 must have this method return the integer 3.

  Returns:
    3

### getMinorVersion

    int getMinorVersion()

  Returns the minor version of the Servlet API that this servlet container supports. All implementations that comply with Version 3.0 must have this method return the integer 0.

  Returns:
    0

### getEffectiveMajorVersion

    int getEffectiveMajorVersion()

  Gets the major version of the Servlet specification that the application represented by this ServletContext is based on.

  The value returned may be different from `getMajorVersion()`, which returns the major version of the Servlet specification supported by the Servlet container.

  Returns:
    the major version of the Servlet specification that the application represented by this ServletContext is based on
  Throws:
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### getEffectiveMinorVersion

    int getEffectiveMinorVersion()

  Gets the minor version of the Servlet specification that the application represented by this ServletContext is based on.

  The value returned may be different from `getMinorVersion()`, which returns the minor version of the Servlet specification supported by the Servlet container.

  Returns:
    the minor version of the Servlet specification that the application xrepresented by this ServletContext is based on
  Throws:
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### getMimeType

    java.lang.String getMimeType(java.lang.String file)

  Returns the MIME type of the specified file, or `null` if the MIME type is not known. The MIME type is determined by the configuration of the servlet container, and may be specified in a web application deployment descriptor. Common MIME types include `text/html` and `image/gif`.

  Parameters:
    `file` - a `String` specifying the name of a file
  Returns:
    a `String` specifying the file's MIME type

### getResourcePaths

    java.util.Set<java.lang.String> getResourcePaths(java.lang.String path)

  Returns a directory-like listing of all the paths to resources within the web application whose longest sub-path matches the supplied path argument.

  Paths indicating subdirectory paths end with a `/`.

  The returned paths are all relative to the root of the web application, or relative to the `/META-INF/resources` directory of a JAR file inside the web application's `/WEB-INF/lib` directory, and have a leading `/`.

  For example, for a web application containing: ``

         /welcome.html
         /catalog/index.html
         /catalog/products.html
         /catalog/offers/books.html
         /catalog/offers/music.html
         /customer/login.jsp
         /WEB-INF/web.xml
         /WEB-INF/classes/com.acme.OrderServlet.class
         /WEB-INF/lib/catalog.jar!/META-INF/resources/catalog/moreOffers/books.html

  `getResourcePaths("/")` would return `{"/welcome.html", "/catalog/", "/customer/", "/WEB-INF/"}`, and `getResourcePaths("/catalog/")` would return `{"/catalog/index.html", "/catalog/products.html", "/catalog/offers/", "/catalog/moreOffers/"}`.

  Parameters:
    `path` - the partial path used to match the resources, which must start with a `/`
  Returns:
    a Set containing the directory listing, or null if there are no resources in the web application whose path begins with the supplied path.
  Since:
    Servlet 2.3

### getResource

    java.net.URL getResource(java.lang.String path)
                             throws java.net.MalformedURLException

  Returns a URL to the resource that is mapped to the given path.

  The path must begin with a `/` and is interpreted as relative to the current context root, or relative to the `/META-INF/resources` directory of a JAR file inside the web application's `/WEB-INF/lib` directory. This method will first search the document root of the web application for the requested resource, before searching any of the JAR files inside `/WEB-INF/lib`. The order in which the JAR files inside `/WEB-INF/lib` are searched is undefined.

  This method allows the servlet container to make a resource available to servlets from any source. Resources can be located on a local or remote file system, in a database, or in a `.war` file.

  The servlet container must implement the URL handlers and `URLConnection` objects that are necessary to access the resource.

  This method returns `null` if no resource is mapped to the pathname.

  Some containers may allow writing to the URL returned by this method using the methods of the URL class.

  The resource content is returned directly, so be aware that requesting a `.jsp` page returns the JSP source code. Use a `RequestDispatcher` instead to include results of an execution.

  This method has a different purpose than `java.lang.Class.getResource`, which looks up resources based on a class loader. This method does not use class loaders.

  Parameters:
    `path` - a `String` specifying the path to the resource
  Returns:
    the resource located at the named path, or `null` if there is no resource at that path
  Throws:
    `java.net.MalformedURLException` - if the pathname is not given in the correct form

### getResourceAsStream

    java.io.InputStream getResourceAsStream(java.lang.String path)

  Returns the resource located at the named path as an `InputStream` object.

  The data in the `InputStream` can be of any type or length. The path must be specified according to the rules given in `getResource`. This method returns `null` if no resource exists at the specified path.

  Meta-information such as content length and content type that is available via `getResource` method is lost when using this method.

  The servlet container must implement the URL handlers and `URLConnection` objects necessary to access the resource.

  This method is different from `java.lang.Class.getResourceAsStream`, which uses a class loader. This method allows servlet containers to make a resource available to a servlet from any location, without using a class loader.

  Parameters:
    `path` - a `String` specifying the path to the resource
  Returns:
    the `InputStream` returned to the servlet, or `null` if no resource exists at the specified path

### getRequestDispatcher

    RequestDispatcher getRequestDispatcher(java.lang.String path)

  Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path. A `RequestDispatcher` object can be used to forward a request to the resource or to include the resource in a response. The resource can be dynamic or static.

  The pathname must begin with a `/` and is interpreted as relative to the current context root. Use `getContext` to obtain a `RequestDispatcher` for resources in foreign contexts.

  This method returns `null` if the `ServletContext` cannot return a `RequestDispatcher`.

  Parameters:
    `path` - a `String` specifying the pathname to the resource
  Returns:
    a `RequestDispatcher` object that acts as a wrapper for the resource at the specified path, or `null` if the `ServletContext` cannot return a `RequestDispatcher`
  See Also:
    `RequestDispatcher`, `getContext(java.lang.String)`

### getNamedDispatcher

    RequestDispatcher getNamedDispatcher(java.lang.String name)

  Returns a `RequestDispatcher` object that acts as a wrapper for the named servlet.

  Servlets (and JSP pages also) may be given names via server administration or via a web application deployment descriptor. A servlet instance can determine its name using `ServletConfig.getServletName()`.

  This method returns `null` if the `ServletContext` cannot return a `RequestDispatcher` for any reason.

  Parameters:
    `name` - a `String` specifying the name of a servlet to wrap
  Returns:
    a `RequestDispatcher` object that acts as a wrapper for the named servlet, or `null` if the `ServletContext` cannot return a `RequestDispatcher`
  See Also:
    `RequestDispatcher`, `getContext(java.lang.String)`, `ServletConfig.getServletName()`

### getServlet

    Servlet getServlet(java.lang.String name)
                       throws ServletException

  Deprecated. As of Java Servlet API 2.1, with no direct replacement.

  This method was originally defined to retrieve a servlet from a `ServletContext`. In this version, this method always returns `null` and remains only to preserve binary compatibility. This method will be permanently removed in a future version of the Java Servlet API.

  In lieu of this method, servlets can share information using the `ServletContext` class and can perform shared business logic by invoking methods on common non-servlet classes.

  Throws:
    `ServletException`

### getServlets

    java.util.Enumeration<Servlet> getServlets()

  Deprecated. As of Java Servlet API 2.0, with no replacement.

  This method was originally defined to return an `Enumeration` of all the servlets known to this servlet context. In this version, this method always returns an empty enumeration and remains only to preserve binary compatibility. This method will be permanently removed in a future version of the Java Servlet API.

### getServletNames

    java.util.Enumeration<java.lang.String> getServletNames()

  Deprecated. As of Java Servlet API 2.1, with no replacement.

  This method was originally defined to return an `Enumeration` of all the servlet names known to this context. In this version, this method always returns an empty `Enumeration` and remains only to preserve binary compatibility. This method will be permanently removed in a future version of the Java Servlet API.

### log

    void log(java.lang.String msg)

  Writes the specified message to a servlet log file, usually an event log. The name and type of the servlet log file is specific to the servlet container.

  Parameters:
    `msg` - a `String` specifying the message to be written to the log file

### log

    void log(java.lang.Exception exception,
             java.lang.String msg)

  Deprecated. As of Java Servlet API 2.1, use `log(String message, Throwable throwable)` instead.

  This method was originally defined to write an exception's stack trace and an explanatory error message to the servlet log file.

### log

    void log(java.lang.String message,
             java.lang.Throwable throwable)

  Writes an explanatory message and a stack trace for a given `Throwable` exception to the servlet log file. The name and type of the servlet log file is specific to the servlet container, usually an event log.

  Parameters:
    `message` - a `String` that describes the error or exception
    `throwable` - the `Throwable` error or exception

### getRealPath

    java.lang.String getRealPath(java.lang.String path)

  Gets the real path corresponding to the given virtual path.

  For example, if `path` is equal to `/index.html`, this method will return the absolute file path on the server's filesystem to which a request of the form `http://<host>:<port>/<contextPath>/index.html` would be mapped, where `<contextPath>` corresponds to the context path of this ServletContext.

  The real path returned will be in a form appropriate to the computer and operating system on which the servlet container is running, including the proper path separators.

  Resources inside the `/META-INF/resources` directories of JAR files bundled in the application's `/WEB-INF/lib` directory must be considered only if the container has unpacked them from their containing JAR file, in which case the path to the unpacked location must be returned.

  This method returns `null` if the servlet container is unable to translate the given virtual path to a real path.

  Parameters:
    `path` - the virtual path to be translated to a real path
  Returns:
    the real path, or `null` if the translation cannot be performed

### getServerInfo

    java.lang.String getServerInfo()

  Returns the name and version of the servlet container on which the servlet is running.

  The form of the returned string is servername/versionnumber. For example, the JavaServer Web Development Kit may return the string `JavaServer Web Dev Kit/1.0`.

  The servlet container may return other optional information after the primary string in parentheses, for example, `JavaServer Web Dev Kit/1.0 (JDK 1.1.6; Windows NT 4.0 x86)`.

  Returns:
    a `String` containing at least the servlet container name and version number

### getInitParameter

    java.lang.String getInitParameter(java.lang.String name)

  Returns a `String` containing the value of the named context-wide initialization parameter, or `null` if the parameter does not exist.

  This method can make available configuration information useful to an entire web application. For example, it can provide a webmaster's email address or the name of a system that holds critical data.

  Parameters:
    `name` - a `String` containing the name of the parameter whose value is requested
  Returns:
    a `String` containing at least the servlet container name and version number
  See Also:
    `ServletConfig.getInitParameter(java.lang.String)`

### getInitParameterNames

    java.util.Enumeration<java.lang.String> getInitParameterNames()

  Returns the names of the context's initialization parameters as an `Enumeration` of `String` objects, or an empty `Enumeration` if the context has no initialization parameters.

  Returns:
    an `Enumeration` of `String` objects containing the names of the context's initialization parameters
  See Also:
    `ServletConfig.getInitParameter(java.lang.String)`

### setInitParameter

    boolean setInitParameter(java.lang.String name,
                             java.lang.String value)

  Sets the context initialization parameter with the given name and value on this ServletContext.

  Parameters:
    `name` - the name of the context initialization parameter to set
    `value` - the value of the context initialization parameter to set
  Returns:
    true if the context initialization parameter with the given name and value was set successfully on this ServletContext, and false if it was not set because this ServletContext already contains a context initialization parameter with a matching name
  Throws:
    `java.lang.IllegalStateException` - if this ServletContext has already been initialized
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### getAttribute

    java.lang.Object getAttribute(java.lang.String name)

  Returns the servlet container attribute with the given name, or `null` if there is no attribute by that name.

  An attribute allows a servlet container to give the servlet additional information not already provided by this interface. See your server documentation for information about its attributes. A list of supported attributes can be retrieved using `getAttributeNames`.

  The attribute is returned as a `java.lang.Object` or some subclass.

  Attribute names should follow the same convention as package names. The Java Servlet API specification reserves names matching `java.*`, `javax.*`, and `sun.*`.

  Parameters:
    `name` - a `String` specifying the name of the attribute
  Returns:
    an `Object` containing the value of the attribute, or `null` if no attribute exists matching the given name
  See Also:
    `getAttributeNames()`

### getAttributeNames

    java.util.Enumeration<java.lang.String> getAttributeNames()

  Returns an `Enumeration` containing the attribute names available within this ServletContext.

  Use the `getAttribute(java.lang.String)` method with an attribute name to get the value of an attribute.

  Returns:
    an `Enumeration` of attribute names
  See Also:
    `getAttribute(java.lang.String)`

### setAttribute

    void setAttribute(java.lang.String name,
                      java.lang.Object object)

  Binds an object to a given attribute name in this ServletContext. If the name specified is already used for an attribute, this method will replace the attribute with the new to the new attribute.

  If listeners are configured on the `ServletContext` the container notifies them accordingly.

  If a null value is passed, the effect is the same as calling `removeAttribute()`.

  Attribute names should follow the same convention as package names. The Java Servlet API specification reserves names matching `java.*`, `javax.*`, and `sun.*`.

  Parameters:
    `name` - a `String` specifying the name of the attribute
    `object` - an `Object` representing the attribute to be bound

### removeAttribute

    void removeAttribute(java.lang.String name)

  Removes the attribute with the given name from this ServletContext. After removal, subsequent calls to `getAttribute(java.lang.String)` to retrieve the attribute's value will return `null`.

  If listeners are configured on the `ServletContext` the container notifies them accordingly.

  Parameters:
    `name` - a `String` specifying the name of the attribute to be removed

### getServletContextName

    java.lang.String getServletContextName()

  Returns the name of this web application corresponding to this ServletContext as specified in the deployment descriptor for this web application by the display-name element.

  Returns:
    The name of the web application or null if no name has been declared in the deployment descriptor.
  Since:
    Servlet 2.3

### addServlet

    ServletRegistration.Dynamic addServlet(java.lang.String servletName,
                                           java.lang.String className)

  Adds the servlet with the given name and class name to this servlet context.

  The registered servlet may be further configured via the returned `ServletRegistration` object.

  The specified `className` will be loaded using the classloader associated with the application represented by this ServletContext.

  If this ServletContext already contains a preliminary ServletRegistration for a servlet with the given `servletName`, it will be completed (by assigning the given `className` to it) and returned.

  This method introspects the class with the given `className` for the `ServletSecurity`, `MultipartConfig`, `javax.annotation.security.RunAs`, and `javax.annotation.security.DeclareRoles` annotations. In addition, this method supports resource injection if the class with the given `className` represents a Managed Bean. See the Java EE platform and JSR 299 specifications for additional details about Managed Beans and resource injection.

  Parameters:
    `servletName` - the name of the servlet
    `className` - the fully qualified class name of the servlet
  Returns:
    a ServletRegistration object that may be used to further configure the registered servlet, or `null` if this ServletContext already contains a complete ServletRegistration for a servlet with the given `servletName`
  Throws:
    `java.lang.IllegalStateException` - if this ServletContext has already been initialized
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### addServlet

    ServletRegistration.Dynamic addServlet(java.lang.String servletName,
                                           Servlet servlet)

  Registers the given servlet instance with this ServletContext under the given `servletName`.

  The registered servlet may be further configured via the returned `ServletRegistration` object.

  If this ServletContext already contains a preliminary ServletRegistration for a servlet with the given `servletName`, it will be completed (by assigning the class name of the given servlet instance to it) and returned.

  Parameters:
    `servletName` - the name of the servlet
    `servlet` - the servlet instance to register
  Returns:
    a ServletRegistration object that may be used to further configure the given servlet, or `null` if this ServletContext already contains a complete ServletRegistration for a servlet with the given `servletName` or if the same servlet instance has already been registered with this or another ServletContext in the same container
  Throws:
    `java.lang.IllegalStateException` - if this ServletContext has already been initialized
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
    `java.lang.IllegalArgumentException` - if the given servlet instance implements `SingleThreadModel`
  Since:
    Servlet 3.0

### addServlet

    ServletRegistration.Dynamic addServlet(java.lang.String servletName,
                                           java.lang.Class<? extends Servlet> servletClass)

  Adds the servlet with the given name and class type to this servlet context.

  The registered servlet may be further configured via the returned `ServletRegistration` object.

  If this ServletContext already contains a preliminary ServletRegistration for a servlet with the given `servletName`, it will be completed (by assigning the name of the given `servletClass` to it) and returned.

  This method introspects the given `servletClass` for the `ServletSecurity`, `MultipartConfig`, `javax.annotation.security.RunAs`, and `javax.annotation.security.DeclareRoles` annotations. In addition, this method supports resource injection if the given `servletClass` represents a Managed Bean. See the Java EE platform and JSR 299 specifications for additional details about Managed Beans and resource injection.

  Parameters:
    `servletName` - the name of the servlet
    `servletClass` - the class object from which the servlet will be instantiated
  Returns:
    a ServletRegistration object that may be used to further configure the registered servlet, or `null` if this ServletContext already contains a complete ServletRegistration for the given `servletName`
  Throws:
    `java.lang.IllegalStateException` - if this ServletContext has already been initialized
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### createServlet

    <T extends Servlet> T createServlet(java.lang.Class<T> clazz)
                                    throws ServletException

  Instantiates the given Servlet class.

  The returned Servlet instance may be further customized before it is registered with this ServletContext via a call to `addServlet(String,Servlet)`.

  The given Servlet class must define a zero argument constructor, which is used to instantiate it.

  This method introspects the given `clazz` for the following annotations: `ServletSecurity`, `MultipartConfig`, `javax.annotation.security.RunAs`, and `javax.annotation.security.DeclareRoles`. In addition, this method supports resource injection if the given `clazz` represents a Managed Bean. See the Java EE platform and JSR 299 specifications for additional details about Managed Beans and resource injection.

  Parameters:
    `clazz` - the Servlet class to instantiate
  Returns:
    the new Servlet instance
  Throws:
    `ServletException` - if the given `clazz` fails to be instantiated
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### getServletRegistration

    ServletRegistration getServletRegistration(java.lang.String servletName)

  Gets the ServletRegistration corresponding to the servlet with the given `servletName`.

  Returns:
    the (complete or preliminary) ServletRegistration for the servlet with the given `servletName`, or null if no ServletRegistration exists under that name
  Throws:
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### getServletRegistrations

    java.util.Map<java.lang.String,? extends ServletRegistration> getServletRegistrations()

  Gets a (possibly empty) Map of the ServletRegistration objects (keyed by servlet name) corresponding to all servlets registered with this ServletContext.

  The returned Map includes the ServletRegistration objects corresponding to all declared and annotated servlets, as well as the ServletRegistration objects corresponding to all servlets that have been added via one of the `addServlet` methods.

  If permitted, any changes to the returned Map must not affect this ServletContext.

  Returns:
    Map of the (complete and preliminary) ServletRegistration objects corresponding to all servlets currently registered with this ServletContext
  Throws:
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### addFilter

    FilterRegistration.Dynamic addFilter(java.lang.String filterName,
                                         java.lang.String className)

  Adds the filter with the given name and class name to this servlet context.

  The registered filter may be further configured via the returned `FilterRegistration` object.

  The specified `className` will be loaded using the classloader associated with the application represented by this ServletContext.

  If this ServletContext already contains a preliminary FilterRegistration for a filter with the given `filterName`, it will be completed (by assigning the given `className` to it) and returned.

  This method supports resource injection if the class with the given `className` represents a Managed Bean. See the Java EE platform and JSR 299 specifications for additional details about Managed Beans and resource injection.

  Parameters:
    `filterName` - the name of the filter
    `className` - the fully qualified class name of the filter
  Returns:
    a FilterRegistration object that may be used to further configure the registered filter, or `null` if this ServletContext already contains a complete FilterRegistration for a filter with the given `filterName`
  Throws:
    `java.lang.IllegalStateException` - if this ServletContext has already been initialized
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### addFilter

    FilterRegistration.Dynamic addFilter(java.lang.String filterName,
                                         Filter filter)

  Registers the given filter instance with this ServletContext under the given `filterName`.

  The registered filter may be further configured via the returned `FilterRegistration` object.

  If this ServletContext already contains a preliminary FilterRegistration for a filter with the given `filterName`, it will be completed (by assigning the class name of the given filter instance to it) and returned.

  Parameters:
    `filterName` - the name of the filter
    `filter` - the filter instance to register
  Returns:
    a FilterRegistration object that may be used to further configure the given filter, or `null` if this ServletContext already contains a complete FilterRegistration for a filter with the given `filterName` or if the same filter instance has already been registered with this or another ServletContext in the same container
  Throws:
    `java.lang.IllegalStateException` - if this ServletContext has already been initialized
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### addFilter

    FilterRegistration.Dynamic addFilter(java.lang.String filterName,
                                         java.lang.Class<? extends Filter> filterClass)

  Adds the filter with the given name and class type to this servlet context.

  The registered filter may be further configured via the returned `FilterRegistration` object.

  If this ServletContext already contains a preliminary FilterRegistration for a filter with the given `filterName`, it will be completed (by assigning the name of the given `filterClass` to it) and returned.

  This method supports resource injection if the given `filterClass` represents a Managed Bean. See the Java EE platform and JSR 299 specifications for additional details about Managed Beans and resource injection.

  Parameters:
    `filterName` - the name of the filter
    `filterClass` - the class object from which the filter will be instantiated
  Returns:
    a FilterRegistration object that may be used to further configure the registered filter, or `null` if this ServletContext already contains a complete FilterRegistration for a filter with the given `filterName`
  Throws:
    `java.lang.IllegalStateException` - if this ServletContext has already been initialized
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### createFilter

    <T extends Filter> T createFilter(java.lang.Class<T> clazz)
                                  throws ServletException

  Instantiates the given Filter class.

  The returned Filter instance may be further customized before it is registered with this ServletContext via a call to `addFilter(String,Filter)`.

  The given Filter class must define a zero argument constructor, which is used to instantiate it.

  This method supports resource injection if the given `clazz` represents a Managed Bean. See the Java EE platform and JSR 299 specifications for additional details about Managed Beans and resource injection.

  Parameters:
    `clazz` - the Filter class to instantiate
  Returns:
    the new Filter instance
  Throws:
    `ServletException` - if the given `clazz` fails to be instantiated
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### getFilterRegistration

    FilterRegistration getFilterRegistration(java.lang.String filterName)

  Gets the FilterRegistration corresponding to the filter with the given `filterName`.

  Returns:
    the (complete or preliminary) FilterRegistration for the filter with the given `filterName`, or null if no FilterRegistration exists under that name
  Throws:
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### getFilterRegistrations

    java.util.Map<java.lang.String,? extends FilterRegistration> getFilterRegistrations()

  Gets a (possibly empty) Map of the FilterRegistration objects (keyed by filter name) corresponding to all filters registered with this ServletContext.

  The returned Map includes the FilterRegistration objects corresponding to all declared and annotated filters, as well as the FilterRegistration objects corresponding to all filters that have been added via one of the `addFilter` methods.

  Any changes to the returned Map must not affect this ServletContext.

  Returns:
    Map of the (complete and preliminary) FilterRegistration objects corresponding to all filters currently registered with this ServletContext
  Throws:
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### getSessionCookieConfig

    SessionCookieConfig getSessionCookieConfig()

  Gets the `SessionCookieConfig` object through which various properties of the session tracking cookies created on behalf of this `ServletContext` may be configured.

  Repeated invocations of this method will return the same `SessionCookieConfig` instance.

  Returns:
    the `SessionCookieConfig` object through which various properties of the session tracking cookies created on behalf of this `ServletContext` may be configured
  Throws:
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### setSessionTrackingModes

    void setSessionTrackingModes(java.util.Set<SessionTrackingMode> sessionTrackingModes)

  Sets the session tracking modes that are to become effective for this `ServletContext`.

  The given `sessionTrackingModes` replaces any session tracking modes set by a previous invocation of this method on this `ServletContext`.

  Parameters:
    `sessionTrackingModes` - the set of session tracking modes to become effective for this `ServletContext`
  Throws:
    `java.lang.IllegalStateException` - if this ServletContext has already been initialized
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
    `java.lang.IllegalArgumentException` - if `sessionTrackingModes` specifies a combination of `SessionTrackingMode.SSL` with a session tracking mode other than `SessionTrackingMode.SSL`, or if `sessionTrackingModes` specifies a session tracking mode that is not supported by the servlet container
  Since:
    Servlet 3.0

### getDefaultSessionTrackingModes

    java.util.Set<SessionTrackingMode> getDefaultSessionTrackingModes()

  Gets the session tracking modes that are supported by default for this `ServletContext`.

  Returns:
    set of the session tracking modes supported by default for this `ServletContext`
  Throws:
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### getEffectiveSessionTrackingModes

    java.util.Set<SessionTrackingMode> getEffectiveSessionTrackingModes()

  Gets the session tracking modes that are in effect for this `ServletContext`.

  The session tracking modes in effect are those provided to `setSessionTrackingModes`.

  By default, the session tracking modes returned by `getDefaultSessionTrackingModes` are in effect.

  Returns:
    set of the session tracking modes in effect for this `ServletContext`
  Throws:
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### addListener

    void addListener(java.lang.String className)

  Adds the listener with the given class name to this ServletContext.

  The class with the given name will be loaded using the classloader associated with the application represented by this ServletContext, and must implement one or more of the following interfaces:

  - `ServletContextAttributeListener`
  - `ServletRequestListener`
  - `ServletRequestAttributeListener`
  - `HttpSessionListener`
  - `HttpSessionAttributeListener`

  If this ServletContext was passed to `ServletContainerInitializer.onStartup(java.util.Set<java.lang.Class<?>>, javax.servlet.ServletContext)`, then the class with the given name may also implement `ServletContextListener`, in addition to the interfaces listed above.

  As part of this method call, the container must load the class with the specified class name to ensure that it implements one of the required interfaces.

  If the class with the given name implements a listener interface whose invocation order corresponds to the declaration order (i.e., if it implements `ServletRequestListener`, `ServletContextListener`, or `HttpSessionListener`), then the new listener will be added to the end of the ordered list of listeners of that interface.

  This method supports resource injection if the class with the given `className` represents a Managed Bean. See the Java EE platform and JSR 299 specifications for additional details about Managed Beans and resource injection.

  Parameters:
    `className` - the fully qualified class name of the listener
  Throws:
    `java.lang.IllegalArgumentException` - if the class with the given name does not implement any of the above interfaces, or if it implements `ServletContextListener` and this ServletContext was not passed to `ServletContainerInitializer.onStartup(java.util.Set<java.lang.Class<?>>, javax.servlet.ServletContext)`
    `java.lang.IllegalStateException` - if this ServletContext has already been initialized
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### addListener

    <T extends java.util.EventListener> void addListener(T t)

  Adds the given listener to this ServletContext.

  The given listener must be an instance of one or more of the following interfaces:

  - `ServletContextAttributeListener`
  - `ServletRequestListener`
  - `ServletRequestAttributeListener`
  - `HttpSessionListener`
  - `HttpSessionAttributeListener`

  If this ServletContext was passed to `ServletContainerInitializer.onStartup(java.util.Set<java.lang.Class<?>>, javax.servlet.ServletContext)`, then the given listener may also be an instance of `ServletContextListener`, in addition to the interfaces listed above.

  If the given listener is an instance of a listener interface whose invocation order corresponds to the declaration order (i.e., if it is an instance of `ServletRequestListener`, `ServletContextListener`, or `HttpSessionListener`), then the listener will be added to the end of the ordered list of listeners of that interface.

  Parameters:
    `t` - the listener to be added
  Throws:
    `java.lang.IllegalArgumentException` - if the given listener is not an instance of any of the above interfaces, or if it is an instance of `ServletContextListener` and this ServletContext was not passed to `ServletContainerInitializer.onStartup(java.util.Set<java.lang.Class<?>>, javax.servlet.ServletContext)`
    `java.lang.IllegalStateException` - if this ServletContext has already been initialized
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### addListener

    void addListener(java.lang.Class<? extends java.util.EventListener> listenerClass)

  Adds a listener of the given class type to this ServletContext.

  The given `listenerClass` must implement one or more of the following interfaces:

  - `ServletContextAttributeListener`
  - `ServletRequestListener`
  - `ServletRequestAttributeListener`
  - `HttpSessionListener`
  - `HttpSessionAttributeListener`

  If this ServletContext was passed to `ServletContainerInitializer.onStartup(java.util.Set<java.lang.Class<?>>, javax.servlet.ServletContext)`, then the given `listenerClass` may also implement `ServletContextListener`, in addition to the interfaces listed above.

  If the given `listenerClass` implements a listener interface whose invocation order corresponds to the declaration order (i.e., if it implements `ServletRequestListener`, `ServletContextListener`, or `HttpSessionListener`), then the new listener will be added to the end of the ordered list of listeners of that interface.

  This method supports resource injection if the given `listenerClass` represents a Managed Bean. See the Java EE platform and JSR 299 specifications for additional details about Managed Beans and resource injection.

  Parameters:
    `listenerClass` - the listener class to be instantiated
  Throws:
    `java.lang.IllegalArgumentException` - if the given `listenerClass` does not implement any of the above interfaces, or if it implements `ServletContextListener` and this ServletContext was not passed to `ServletContainerInitializer.onStartup(java.util.Set<java.lang.Class<?>>, javax.servlet.ServletContext)`
    `java.lang.IllegalStateException` - if this ServletContext has already been initialized
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0

### createListener

    <T extends java.util.EventListener> T createListener(java.lang.Class<T> clazz)
                                                     throws ServletException

  Instantiates the given EventListener class.

  The specified EventListener class must implement at least one of the ``ServletContextListener``, ``ServletContextAttributeListener``, ``ServletRequestListener``, ``ServletRequestAttributeListener``, ``HttpSessionListener``, or ``HttpSessionAttributeListener`` interfaces.

  The returned EventListener instance may be further customized before it is registered with this ServletContext via a call to `addListener(EventListener)`.

  The given EventListener class must define a zero argument constructor, which is used to instantiate it.

  This method supports resource injection if the given `clazz` represents a Managed Bean. See the Java EE platform and JSR 299 specifications for additional details about Managed Beans and resource injection.

  Parameters:
    `clazz` - the EventListener class to instantiate
  Returns:
    the new EventListener instance
  Throws:
    `ServletException` - if the given `clazz` fails to be instantiated
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
    `java.lang.IllegalArgumentException` - if the specified EventListener class does not implement any of the ``ServletContextListener``, ``ServletContextAttributeListener``, ``ServletRequestListener``, ``ServletRequestAttributeListener``, ``HttpSessionListener``, or ``HttpSessionAttributeListener`` interfaces.
  Since:
    Servlet 3.0

### getJspConfigDescriptor

    JspConfigDescriptor getJspConfigDescriptor()

  Gets the `<jsp-config>` related configuration that was aggregated from the `web.xml` and `web-fragment.xml` descriptor files of the web application represented by this ServletContext.

  Returns:
    the `<jsp-config>` related configuration that was aggregated from the `web.xml` and `web-fragment.xml` descriptor files of the web application represented by this ServletContext, or null if no such configuration exists
  Throws:
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
  Since:
    Servlet 3.0
  See Also:
    `JspConfigDescriptor`

### getClassLoader

    java.lang.ClassLoader getClassLoader()

  Gets the class loader of the web application represented by this ServletContext.

  If a security manager exists, and the caller's class loader is not the same as, or an ancestor of the requested class loader, then the security manager's `checkPermission` method is called with a `RuntimePermission("getClassLoader")` permission to check whether access to the requested class loader should be granted.

  Returns:
    the class loader of the web application represented by this ServletContext
  Throws:
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
    `java.lang.SecurityException` - if a security manager denies access to the requested class loader
  Since:
    Servlet 3.0

### declareRoles

    void declareRoles(java.lang.String... roleNames)

  Declares role names that are tested using `isUserInRole`.

  Roles that are implicitly declared as a result of their use within the `setServletSecurity` or `setRunAsRole` methods of the `ServletRegistration` interface need not be declared.

  Parameters:
    `roleNames` - the role names being declared
  Throws:
    `java.lang.UnsupportedOperationException` - if this ServletContext was passed to the `ServletContextListener.contextInitialized(javax.servlet.ServletContextEvent)` method of a `ServletContextListener` that was neither declared in `web.xml` or `web-fragment.xml`, nor annotated with `WebListener`
    `java.lang.IllegalArgumentException` - if any of the argument roleNames is null or the empty string
    `java.lang.IllegalStateException` - if the ServletContext has already been initialized
  Since:
    Servlet 3.0

Copyright © 2012 GlassFish Community. All Rights Reserved.